//+------------------------------------------------------------------+
//|                                                   MA Channel.mq4 |
//+------------------------------------------------------------------+
#property copyright "cja for tsd"

#property indicator_chart_window
#property indicator_buffers 3

#property indicator_color1 Aqua
#property indicator_width1 2
#property indicator_color2 CadetBlue
#property indicator_style2 2
#property indicator_color3 CadetBlue
#property indicator_style3 2

//---- input parameters
extern string note1________ ="upper/lower distance to MA ";
extern int  level_distance  = 30;
extern string note2________ ="MA settings ";
extern int ma_period        = 20;
extern int ma_mode          = 1;
extern int ma_price         = 0;
extern int ma_shift         = 0;

//----
string MA;

double upperlevel[];
double lowerlevel[];
double ma[];

 double myPoint;
 double SetPoint() 
{ 
   double mPoint; 
   
   if (Digits < 4) 
   mPoint = 0.01; 
   else 
   mPoint = 0.0001; 
   
  return(mPoint); 
}


  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  
 
     myPoint = SetPoint(); 
   
    IndicatorBuffers(3);
    
    SetIndexDrawBegin(0,ma_period);
    SetIndexBuffer(0, ma);
    SetIndexStyle(0,DRAW_LINE);
    
    SetIndexDrawBegin(1,ma_period);
    SetIndexBuffer(1, upperlevel);
    SetIndexStyle(1,DRAW_LINE);
    
    SetIndexDrawBegin(2,ma_period);
    SetIndexBuffer(2, lowerlevel);
    SetIndexStyle(2,DRAW_LINE);
    
    IndicatorShortName("MA Channel");
//----
   
    return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
 

    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
    int limit;
    int counted_bars = IndicatorCounted();
//---- check for possible errors
    if(counted_bars < 0) 
        return(-1);
//---- last counted bar will be recounted
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;
//----
   
   string MA;
   
   
    //for(int i = 0; i < limit; i++)
    for(int i=limit; i>=0; i--)
      {
      
       upperlevel[i]=iMA(NULL,0,ma_period,ma_shift,ma_mode,ma_price,i)+level_distance*myPoint;
       lowerlevel[i]=iMA(NULL,0,ma_period,ma_shift,ma_mode,ma_price,i)-level_distance*myPoint;
       ma[i]=iMA(NULL,0,ma_period,ma_shift,ma_mode,ma_price,i);
      
      }
//----
    return(0);
  }
   

